import tableFactory from './table-factory';
import chartFactory from './common-lib';
// export default async function lifeExpectancyTable() {
//   const getData = async() => {
//     try {
//       const response = await fetch('data.json');
//       //console.log(response);
//       const raw = await response.json();
//       //console.log(raw);
//       return raw.fact.filter(d => d.dim.GHO === 'Life expectancy at birth (years)' && d.dim.SEX === 'Both sexes' && d.dim.YEAR==='2014')
//       	.map(d=>[
//         	d.dim.COUNTRY,
//         	d.Value
//         ]);
        
//     } catch (e) {
//       console.error(e);
//       return undefined;
//     }
//   }
//   const data = await getData()
//   data.unshift(['Country','Life expectancy (years from birth)']);
//   return tableFactory(data).table
//   	.selectAll('tr')
//     .filter(i=>i)
//   	.sort(([countryA,yearsA], [countryB, yearsB])=>yearsA-yearsB);
// }

export async function renderSVGStuff() {
  const chart = chartFactory();
  const text = chart.container.append('text')
  	.text("Ceci n'est pas un trajet")
  	.attr('x',50)
  	.attr('y',200)
  	.attr('text-anchor','start');
  
  const circle = chart.container.append('circle')
  	.attr('cx',350)
  	.attr('cy',250)
  	.attr('r',100)
  	.attr('fill','green')
  	.attr('fill-opacity',0.5)
  	.attr('stroke','steelblue')
  	.attr('stroke-width',2);
  
  const ellipse = chart.container.append('ellipse')
  	.attr('cx',350)
  	.attr('cy',250)
  	.attr('rx',150)
  	.attr('ry',70)
  	.attr('fill','green')
  	.attr('fill-opacity',0.3)
  	.attr('stroke','steelblue')
  	.attr('stroke-width',0.7);
  
  chart.container.append('ellipse')
  	.attr('cx',350)
  	.attr('cy',250)
  	.attr('rx',80)
  	.attr('ry',7);
  
  const line = chart.container.append('line')
  	.attr('x1',10)
  	.attr('y1',10)
  	.attr('x2',100)
  	.attr('y2',100)
  	.attr('stroke','blue')
  	.attr('stroke-width',3);
  
  const rect = chart.container.insert('rect','circle')
  	.attr('x',200)
  	.attr('y',50)
  	.attr('width',300)
  	.attr('height',400)
  	.attr('stroke','green')
  	.attr('stroke-width',0.5)
  	.attr('fill','white')
  	.attr('rx',20)
  	.attr('ry',4)
  
  chart.container.selectAll('ellipse,circle')
  	.attr('transform',`translate(150,0) 
			scale(1.2)         
			translate(-250,0)
			rotate(-45,${350/1.2},${250/1.2}) 
  		skewY(20)
					`) 
}

export function yayPaths() {
  const chart = chartFactory();
  const sine = d3.range(0,10)
  	.map(k=>[0.5*k*Math.PI,Math.sin(0.5*k*Math.PI)]);
  
  const x = d3.scaleLinear()
  	.range([
      0,
      (chart.width/2)-(chart.margin.left+chart.margin.right),
      ])
  	.domain(d3.extent(sine,d=>d[0]));
  
  const y = d3.scaleLinear()
  	.range([
      (chart.height / 2) - (chart.margin.top + chart.margin.bottom),
      0,
      ])
  	.domain([-1,1]);
  
  const line = d3.line()
  	.x(d=>x(d[0]))
  	.y(d=>y(d[1]))
  
  const g = chart.container.append('g');
  g.append('path')
  	.datum(sine)
  	.attr('d',line)
  	.attr('stroke','steelblue')
  	.attr('stroke-width',2)
  	.attr('fill','none');
  g.append('path')
  	.datum(sine)
  	.attr('d',line.curve(d3.curveStepBefore))
  	.attr('stroke','steelblue')
  	.attr('stroke-width',2)
  	.attr('fill','none');
  
  const g2 = chart.container.append('g')
  	.attr('transform',
          `translate(${(chart.width/2) +(chart.margin.left+chart.margin.right)},${chart.margin.top})`);
	const area = d3.area()
  	.x(d=>x(d[0]))
  	.y0(chart.height/2)
  	.y1(d=>y(d[1]))
  	.curve(d3.curveBasis);
  g2.append('path')
  	.datum(sine)
  	.attr('d',area)
  	.attr('fill','steelblue')
  	.attr('fill-opacity',0.4);
  
  g2.append('path')
  	.datum(sine)
  	.attr('d',line.curve(d3.curveBasis))
  	.attr('stroke','steelblue')
  	.attr('stroke-width',3)
  	.attr('fill','none');
  
  const arc = d3.arc();
  const g3 = chart.container.append('g')
  	.attr('transform',
          `translate(${chart.margin.left+chart.margin.right}, ${(chart.height/2)+(chart.margin.top+chart.margin.bottom)})`);
	g3.append('path')
  	.attr('d',
          	arc({
    					outerRadius:100,
    					innerRadius: 50,
    					startAngle: -Math.PI*0.25,
    					endAngle: Math.PI*0.25
  					}))
  	.attr('transform','translate(150,150)')
  	.attr('fill','lightslategrey');
  
  const symbols = d3.symbol()
  	.type(d=> (d[1]>0 ? d3.symbolTriangle : d3.symbolDiamond))
  	.size((d,i) => (i % 2 ? 0 : 64));
  g2.selectAll('path')
  	.data(sine)
  	.enter()
  	.append('path')
  	.attr('d',symbols)
  	.attr('stroke','steelblue')
  	.attr('stroke-width',2)
  	.attr('fill','white')
  	.attr('transform',d=> `translate(${x(d[0])},${y(d[1])})`);
  
  // g3.append('g')
  // 	.selectAll('path')
  // 	.data([{
  //     source: {
  //       radius: 50,
  //       startAngle: -Math.PI * 0.3,
  //       endAngle: -Math.PI * 0.2
  //     },
  //     target: {
  //       radius: 50,
  //       startAngle: Math.PI * 0.3,
  //       endAngle: Math.PU * 0.3
  //     }
  //   }])
  // 	.enter()
  // 	.append('path')
  // 	.attr('transform','translate(350,150)')
  // 	.attr('d',d3.ribbon());
  
  const data = d3.zip(d3.range(0,12), d3.shuffle(d3.range(0,12)));
  const colors = ['linen','lightsteelblue','lightcyan','lavender','honeydew','gainsboro'];
  const ribbon = d3.ribbon()
  	.source(d=>d[0])
  	.target(d=>d[1])
  	.radius(90)
  	.startAngle(d=> -2* Math.PI * (1/data.length) * d)
  	.endAngle(d => -2* Math.PI * (1/data.length) * ((d-1) % data.length));
  g3.append('g')
  	.attr('transform','translate(400,100)')
  	.selectAll('path')
  	.data(data)
  	.enter()
  	.append('path')
  	.attr('d',ribbon)
  	.attr('fill',(d,i)=> colors[i % colors.length])
  	.attr('stroke',(d,i) =>colors[(i+1) % colors.length]);
}

export function axisDemos() {
  const chart = chartFactory({
    margin: {top: 30, bottom: 10, left: 50, right: 50}
  })
  const amount = 200;
  const x = d3.scaleLinear()
  	.domain([0,amount])
  	.range([
      0,
      chart.width - chart.margin.right - chart.margin.left - 20
      ]);
  const axis = d3.axisBottom()
  	.scale(x);
  const axes = [
    d3.axisBottom().scale(x),
    d3.axisTop().scale(x).ticks(5),
    d3.axisBottom().scale(x).tickSize(10,5,10),
    d3.axisTop().scale(x).tickValues([0,20,50,70,100])
    	.tickFormat((d,i)=>['a','e','i','o','u'][i])
    ];
  axes.forEach((axis,i) =>
              chart.container.append('g')
               	.data(d3.range(0,amount))
               	.attr('transform',
                      `translate(0,${(i*50) + chart.margin.top})`)
               	.call(axis)
               );
}
//yayPaths();
//renderSVGStuff();
//axisDemos();